#ifndef INCLUDE_DD__WINDOW_H
#define INCLUDE_DD__WINDOW_H

#include <gdk/gdkx.h>
#include <X11/Xlib.h>

#include <gtk/gtk.h>

#define DD_TYPE_WINDOW            (dd_window_get_type())
#define DD_WINDOW(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), DD_TYPE_WINDOW, DdWindow))
#define DD_WINDOW_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), DD_TYPE_WINDOW, DdWindowClass))
#define DD_IS_WINDOW(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), DD_TYPE_WINDOW))
#define DD_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), DD_TYPE_WINDOW))
#define DD_WINDOW_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), DD_TYPE_WINDOW, DdWindowClass))

typedef struct DdWindow DdWindow;

typedef struct {
	GtkWindowClass parent_object;

	void (*workarea_changed)(DdWindow *);
} DdWindowClass;

struct DdWindow {
	GtkWindow parent_object;

	Window       old_desktop;
	GdkRectangle workarea;
};

GType dd_window_get_type(void);

DdWindow *dd_window_new(void);

G_CONST_RETURN GdkRectangle *dd_window_get_workarea(const DdWindow *);

void dd_window_add(DdWindow *, GtkWidget *);
void dd_window_add_in_workarea_with_fixed(DdWindow *, GtkWidget *);

#endif
